var g_picture;
var g_console;
var g_sitedescription;
var g_options;
var g_inventory;
var g_places;
var g_points;
var g_leftpointer;
var g_rightpointer;

var g_tools = {};
var g_sites = {};

var g_deathcounter = 0;
var g_pointcounter = 0;

function clearchildren(node){
	while (node.firstChild) {
		node.removeChild(node.firstChild);
	}
}

function createButton(html, cssclass){
	var iDiv = document.createElement('div');
	iDiv.innerHTML = html;
	iDiv.className = cssclass;
	iDiv.style.cursor = "grab";
	return iDiv;
}

function Clickable(name, cstyle){
	this.name = name;
	this.button = null;
	this.cstyle = cstyle;
	this.setbutton(name);
}
Clickable.prototype.setbutton = function(html){
	this.button = createButton(html, this.cstyle);
}

function Tool(name, value){
	Clickable.call(this, name, "toolbutton");
	this.value = value;
	this.description = "";
	this.owned = false;
	this.defaction = false;
	g_tools[name] = this;
	var ethis = this;
	this.button.onclick = function(){
		g_actsite.usetool(ethis);
		g_pointcounter-=ethis.value;
	}
}
Tool.prototype = Object.create( Clickable.prototype );

function Optionc(name, owner, action, num){
	code = '<table><tr><td><img src="design/'+num+'button.png"/></td><td valign="center"><b>' + name + '</b></td></tr></table>';
	Clickable.call(this, code, "optionbutton");
	this.owner = owner;
	this.action = action;
}
Optionc.prototype = Object.create( Clickable.prototype );

function Site(name){
	Clickable.call(this, name, "sitebutton");
	this.description = "";
	this.img = "images/"+name+".png";
	this.options = [];
	this.vars = {};
	this.reachable = false;
	this.openAction = function(){};
	this.closeAction = function(){};
	this.deadend = false;
	g_sites[name] = this;
	var ethis = this;
	this.button.onclick = function(){
		refresh(ethis);
	};
	this.toolrelays = [];
}
Site.prototype = Object.create( Clickable.prototype );


Site.prototype.addOption = function(name, action){
	o = new Optionc(name, this, action, this.options.length);
	o.button.onclick = action;
	this.options.push(o);
	return o;
}

Site.prototype.removeOption = function(optionobj){
	var index = this.options.indexOf(optionobj);
	if (index > -1){
		this.options.splice(index, 1);
	}
};

Site.prototype.addToolRelay = function(toolname, action) {
	this.toolrelays.push([toolname, action]);
}

Site.prototype.usetool = function(tool){
	for (var relay of this.toolrelays){
		if (relay[0] == tool.name){
			relay[1]();
			return;
		}
	}
	if (tool.defaction){
		tool.defaction();
	} else {
		printc(tool.name + " itt nem használható");
	}
}

Site.prototype.show = function(){
	imgFix_DEMO_HTML = String.raw`onerror="this.onerror=null; this.src='images/Untitled.png'" alt="" width="320" height="200"`;
	g_picture.innerHTML = "<img src='" + this.img + "' "+ imgFix_DEMO_HTML +" />";

	clearchildren(g_options);
	clearchildren(g_console);
	if (this.deadend == true && this.options.length == 0){
		o = new Optionc("halál!", this, resurrect, 66);
		o.button.onclick = resurrect;
		this.options.push(o);
		if (g_pointcounter > 0) {
			o = new Optionc("ɥʇɐǝp", this, redeem, 99);
			o.button.onclick = redeem    ;
			this.options.push(o);
		}
	}
	for (var o of this.options){
		g_options.appendChild(o.button);
	}
	g_sitedescription.innerHTML = this.description;
	g_actsite = this;
}

var g_actsite = null;

function refresh(site){
	if (!site){
		if (g_actsite){
			site = g_actsite;
		} else {
			site = g_sites["start"];
		}
	}
	if (g_actsite != site){
		if (g_actsite) {
			g_actsite.closeAction()
		}
		site.openAction();
	}
	clearchildren(g_points)
	if ("p" in site){
		g_pointcounter += site.p;
		g_points.innerHTML = "pontok: "+g_pointcounter;
	}
	clearchildren(g_places)
	for (var s in g_sites){
		if (g_sites[s].reachable && s != site.name){
			g_places.appendChild(g_sites[s].button);
		}
	}
	clearchildren(g_inventory)
	for (var t in g_tools){
		var gotja = false;
		for (var relay of site.toolrelays){
			if (relay[0] == g_tools[t].name){
				gotja = true;
				break;
			}
		}
		if (gotja){
			g_tools[t].button.className = "usetool";
		} else {
			g_tools[t].button.className = "uselesstool";
		}
		if (g_tools[t].owned){
			g_inventory.appendChild(g_tools[t].button);
		}
	}
	site.show();
}

function jump(site){
	refresh(site);
}

function resurrect(){
	jump(resursite);
}

function redeem(){
	jump(redeemsite);
}

function printc(text){
	g_console.innerHTML += "<div>"+text+"</div>";
}

function start(){
	g_picture = document.getElementById("picture");
	g_console = document.getElementById("console");
	g_sitedescription = document.getElementById("sitedescription");
	g_options = document.getElementById("options");
	g_inventory = document.getElementById("inventory");
	g_places = document.getElementById("places");
	g_points = document.getElementById("points");
	g_leftpointer = document.getElementById("leftpoint");
	g_rightpointer = document.getElementById("rightpoint");
	refresh();
}

function bigerror(){
	const fuckup_error = "HÁT EZT ELBASZTAD MIT KATTINGATSZ ÖSSZE-VISSZA?<br/><h4>Fenerák Proteksön Fólt</h4><br/>	<h5>... listing memory ...<br/>	veri big hererák in CPU kes<br/>	sysztem sáting dáun</h5>";
	return fuckup_error;
}
function version(html){
	const versioncc = html+"<br/><b>Arock (ii) Game</b><br/>.2020.<h3>demo ver.-</h3>";
	return versioncc;
}
